/*
 * (C) Copyright 2001 Sysgo Real-Time Solutions, GmbH <www.elinos.com>
 * Andreas Heppel <aheppel@sysgo.de>
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/*
 * memory routines for the MPC106 CPU.
 */
 
#include <ppcboot.h>
#include <config.h>
#include <mpc106.h>

 
/*
 * The local DRAM may have a different address from the PCI
 * point of view, thus buffer addresses have to be modified
 * [mapped] appropriately.
 */
unsigned long phys_to_bus(void * address)
{
	if (address == (void *)0)
		return 0;
	return (unsigned long)address + CFG_PCI_DRAM_OFFSET;
}
 
void * bus_to_phys(unsigned long address)
{
	if (address == 0)
		return 0;
	return (void *)(address - CFG_PCI_DRAM_OFFSET);
}
