/*
 * (C) Copyright 2000
 * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <ppcboot.h>
#include <mpc75x.h>
#include <asm/processor.h>

/*
 * 7xx CPU specific modifications by
 * Andreas Heppel <aheppel@sysgo.de>
 */
 
 
/* Access functions for the Machine State Register */
static __inline__ unsigned long
get_msr(void)
{
	unsigned long msr;

	asm volatile("mfmsr %0" : "=r" (msr) :);
	return msr;
}

static __inline__ void
set_msr(unsigned long msr)
{
	asm volatile("mtmsr %0" : : "r" (msr)); 
}

/* ------------------------------------------------------------------------- */

/*
 * Measure CPU clock speed (core clock GCLK1)
 *
 * (Approx. GCLK frequency in Hz)
 */
short pllratio_to_factor[] = {
    00, 75, 70, 00, 20, 65, 100, 45, 30, 55, 40, 50, 80, 60, 35, 00,
};

ulong
get_gclk_freq (void)
{
	uint hid1 = mfspr(HID1);

	hid1 = (hid1 >> (32-4)) & 0xf;

	return (pllratio_to_factor[hid1] * get_bus_freq(0)) / 10;
}

/* ------------------------------------------------------------------------- */

